import settings
import requests
import json

GRAPHQL_API = settings.GraphQlApi
TENANT_ID = settings.TenantId
TENANT_KEY = settings.TenantKey

def GetSpacesWithPoints():
    #GraphQL Server URL
    target = GRAPHQL_API
    
    # HTTP Header
    headers = {
        "x-tenant-id": TENANT_ID,
        "x-tenant-key": TENANT_KEY,
    }

    # Create GraphQL Query/Mutation
    query = """query LIST_SPACES_WITH_POINTS {
    spaces {
      id
      name
      points {
        id
        name
        }
      }
    }"""

    jsonform = {
        "query": query,
        "variables": {
        },
    }
    
    print("Reading data...")
    try:
        res = requests.post(target, json=jsonform, headers=headers)
    except Exception as e:
        print(f"Error!: {e}")

    if res.status_code != 200:
        print("Send error!")
        print(res.text)

    else:
        res_json = res.json()
        if "errors" in res_json.keys():
            print("Query error!")
            print(res_json["errors"])
        else:
            print("Success!")
            # Parse JSON Data
            data = str(res_json["data"])
            data = data.replace("'", '"')
            jsondata = json.loads(data)
            jsonString = json.dumps(jsondata, indent=1)
            
    return jsonString


data = GetSpacesWithPoints()
print(data)